#include <iostream>
#include "kernel_ctx/kernel_ctx.h"
#include "mem_ctx/mem_ctx.hpp"

int __cdecl main(int argc, char** argv)
{
	nasa::load_drv();
	nasa::kernel_ctx kernel;
	if (kernel.clear_piddb_cache(nasa::drv_key, util::get_file_header((void*)raw_driver)->TimeDateStamp))
		std::cout << "[+] Removed PIDDB Cache entry for physmeme driver..." << std::endl;
	nasa::unload_drv();

	const std::pair<unsigned, virt_addr_t> my_proc_data = { GetCurrentProcessId(), virt_addr_t{ GetModuleHandle(NULL) } };
	std::cout << "[+] my pid: " << std::hex << my_proc_data.first << std::endl;
	std::cout << "[+] my base: " << std::showbase << std::hex << my_proc_data.second.value << std::endl;

	nasa::mem_ctx my_proc(kernel, my_proc_data.first);
	const auto module_base = my_proc_data.second;

	std::cout << "[+] base address pml4e: " << std::hex << my_proc[module_base.pml4_index].value << std::endl;
	std::cout << "[+] base address pdpte: " << std::hex << my_proc[{module_base.pml4_index, module_base.pdpt_index}].value << std::endl;
	std::cout << "[+] base address pde: " << std::hex << my_proc[{module_base.pml4_index, module_base.pdpt_index, module_base.pd_index}].value << std::endl;
	std::cout << "[+] base address pte: " << std::hex << my_proc[{module_base.pml4_index, module_base.pdpt_index, module_base.pd_index, module_base.pt_index}].value << std::endl;
	std::cin.get();
}